/*4:*/
//line 91 "./o2externs.w"

#ifndef o2_externs_ 
#define o2_externs_ 1 

//line 94 "./o2externs.w"

/*5:*/
//line 99 "./o2externs.w"

#include "globals.h" 
#include "o2_types.h" 
#include "o2_lcl_opts.h" 
#include "o2_lcl_opt.h" 
#include "pass3.h" 
#include "o2_err_hdlr.h" 
#include "fsm_phrase.h" 
#include "parallel_parser_phrase.h" 
#include "T_enum_phrase.h" 
#include "err_symbols_ph.h" 
#include "rc_phrase.h" 
#include "lr1_k_phrase.h" 
#include "terminals_phrase.h" 
#include "rules_phrase.h" 
#include "yacco2_stbl.h" 
#include "enumerate_T_alphabet.h" 
#include "mpost_output.h" 
#include "prt_xrefs_docs.h" 
#include "cweb_put_k_into_ph.h" 
extern CYCLIC_USE_TBL_type CYCLIC_USE_TABLE;
extern STBL_T_ITEMS_type STBL_T_ITEMS;
extern int NO_LR1_STATES;
extern T_fsm_phrase*O2_FSM_PHASE;
extern T_parallel_parser_phrase*O2_PP_PHASE;
extern T_enum_phrase*O2_T_ENUM_PHASE;
extern T_lr1_k_phrase*O2_LRK_PHASE;
extern T_rc_phrase*O2_RC_PHASE;
extern T_error_symbols_phrase*O2_ERROR_PHASE;
extern T_terminals_phrase*O2_T_PHASE;
extern T_rules_phrase*O2_RULES_PHASE;
extern STATES_type LR1_STATES;
extern RULE_ENO START_OF_RULES_ENUM;
extern STBL_T_ITEMS_type STBL_T_ITEMS;
extern RULE_ENO START_OF_RULES_ENUM;
extern yacco2::AST*GRAMMAR_TREE;
extern yacco2::AST*CWEB_MARKER;
extern void WRT_CWEB_MARKER(std::ofstream*Wfile,yacco2::AST*Cweb_marker);
extern void LOAD_YACCO2_KEYWORDS_INTO_STBL();
extern void GET_CMD_LINE(int argc,char*argv[]
,const char*File,yacco2::TOKEN_GAGGLE&Errors);
extern void DUMP_ERROR_QUEUE(yacco2::TOKEN_GAGGLE&Errors);
extern void PRINT_RULES_TREE_STRUCTURE(AST*Node);
extern const char*DATE_AND_TIME();
extern void YACCO2_PARSE_CMD_LINE
(yacco2::CHAR&T_sw
,yacco2::CHAR&ERR_sw,yacco2::CHAR&PRT_sw
,std::string&Grammar_to_compile
,yacco2::TOKEN_GAGGLE&Error_queue);
extern bool PROCESS_INCLUDE_FILE
(yacco2::Parser&Calling_parser
,NS_yacco2_terminals::T_file_inclusion&File_include
,yacco2::token_container_type&T2);
extern bool PROCESS_KEYWORD_FOR_SYNTAX_CODE
(yacco2::Parser&Parser
,yacco2::CAbs_lr1_sym*Keyword
,yacco2::CAbs_lr1_sym**Cont_tok
,yacco2::INT*Cont_pos);
extern void BUILD_GRAMMAR_TREE(yacco2::AST&Item);
extern void PRINT_GRAMMAR_TREE(AST*Node);
extern void GEN_FS_OF_RULE(NS_yacco2_terminals::rule_def*Rule_def);
extern void GEN_CALLED_THREADS_FS_OF_RULE
(NS_yacco2_terminals::rule_def*Start_rule);
extern int MAX_USE_CNT_RxR
(NS_yacco2_terminals::rule_def*Rule_use
,NS_yacco2_terminals::rule_def*Against_rule);
extern void XLATE_SYMBOLS_FOR_cweave(const char*Sym_to_xlate,char*Xlated_sym);
extern void PRT_RULE_S_FIRST_SET(NS_yacco2_terminals::rule_def*Rule_def);
extern void OP_GRAMMAR_HEADER(TOKEN_GAGGLE&Error_queue);
extern void OP_GRAMMAR_CPP(TOKEN_GAGGLE&Error_queue);
extern void OP_GRAMMAR_SYM(TOKEN_GAGGLE&Error_queue);
extern void OP_GRAMMAR_TBL(TOKEN_GAGGLE&Error_queue);
extern void OP_ENUMERATION_HEADER(TOKEN_GAGGLE&Error_queue);
extern void OP_T_Alphabet(TOKEN_GAGGLE&Error_queue);
extern void OP_ERRORS_HEADER(TOKEN_GAGGLE&Error_queue);
extern void OP_ERRORS_CPP(TOKEN_GAGGLE&Error_queue);
extern void OP_USER_T_HEADER(TOKEN_GAGGLE&Error_queue);
extern void OP_USER_T_CPP(TOKEN_GAGGLE&Error_queue);
extern void OP_FSC_FILE(TOKEN_GAGGLE&Error_queue);
extern void Print_dump_state(state*State);
/*:5*/
//line 95 "./o2externs.w"

#endif 

/*:4*/
